<template>
  <div class="sa-multisearch">
    <button
      :id="uniqueId"
      ref="button"
      :class="buttonClasses"
      aria-haspopup="listbox"
      :aria-expanded="dropdownOpen"
      @click="toggleDropdown()"
    >
      <span>{{ buttonLabel }}</span>
      <sa-icon icon="chevron-down" />
    </button>
    <div
      v-show="dropdownOpen"
      ref="dropdown"
      class="dropdown"
      :class="align"
      :style="{ maxHeight: `calc(100vh - ${dropdownTop}px - 8px)` }"
      role="listbox"
      :aria-labelledby="uniqueId"
      tabindex="0"
      @keydown.esc.prevent="closeDropdown"
      @focusout="onDropdownFocusOut"
    >
      <div class="header">
        <div class="label">
          Search
          <button
            v-if="allSelectedValues.length"
            class="link-button"
            @click="selectNone()"
          >
            Clear
          </button>
        </div>
        <sa-caption text="Use commas to enter multiple values" />
        <sa-input-search
          ref="searchInput"
          class="search-input"
          size="small"
          @change="onSearchChange"
          @search="onSearchEnter"
        />
      </div>
      <sa-option-list
        :disabled="searchSuggestionsLoading"
        :options="searchSuggestions"
        :selection="allSelectedValues"
        @toggle="onOptionSelect"
      />
      <sa-caption v-if="searchSuggestionsLoading">
        <sa-icon icon="loader" spin />
        Searching...
      </sa-caption>
      <sa-caption
        v-else-if="searchSuggestionsError"
        type="danger"
        text="Unable to retrieve results"
      />
      <sa-caption v-else-if="searchSuggestionsTotal === 0" text="No results" />
      <sa-caption v-else-if="searchSuggestionsTotal > suggestionLimit">
        + {{ searchSuggestionsTotal - suggestionLimit }}
        more results; refine search
      </sa-caption>
      <div v-if="pendingValues.length" class="result-section pending-section">
        <div v-for="value in pendingValues" :key="value">
          <sa-chip
            :size="chipSize"
            :can-delete="!validatedError"
            selected
            :loading="!validatedError"
            :disabled="validatedError"
            :text="value"
            @delete="removeValue('pendingValues', value)"
          />
        </div>
        <sa-caption v-if="validatedError" type="danger">
          Unable to verify status
          <button
            class="link-button"
            data-test-id="retry"
            @click="validatePendingValues"
          >
            Retry
          </button>
        </sa-caption>
      </div>
      <div v-if="invalidValues.length" class="result-section">
        <sa-caption :text="`${invalidValues.length} not found`" />
        <div v-for="value in invalidValues" :key="value">
          <sa-chip
            :size="chipSize"
            can-delete
            selected
            type="danger"
            icon="x-circle"
            :text="value"
            @delete="removeValue('invalidValues', value)"
          />
        </div>
      </div>
      <div v-if="validValues.length" class="result-section">
        <sa-caption :text="`${validValues.length} selected`" />
        <div v-for="value in validValues" :key="value">
          <sa-chip
            :size="chipSize"
            can-delete
            selected
            type="success"
            icon="check-circle"
            :text="value"
            @delete="removeValue('validValues', value)"
          />
        </div>
      </div>
    </div>
  </div>
</template>

<script>
import SaOptionList from '@/components/_utils/optionList/SaOptionList'

export default {
  name: 'SaMultisearch',
  components: { SaOptionList },
  props: {
    /** ID corresponding to the field in the model which to search */
    filterId: {
      type: String,
      required: true
    },
    /** Maximum number of typeahead suggestions to show */
    suggestionLimit: {
      type: Number,
      default: 5
    },
    /** @values small, regular, large */
    size: {
      type: String,
      default: 'regular'
    },
    /** Field display name */
    label: {
      type: String,
      default: 'Search'
    },
    /** Allow the input to grow to fill the available width */
    fullWidth: {
      type: Boolean,
      default: false
    },
    /**
     * Which side to align the button and dropdown panel
     * @values left, right
     */
    align: {
      type: String,
      default: 'left'
    },
    /** Items which should be selected when rendering the component */
    initialSelection: {
      type: Array,
      default: () => []
    }
  },

  data(props) {
    return {
      dropdownOpen: false,
      dropdownTop: 0,
      uniqueId: this.makeUniqueId(),
      pendingValues: [...props.initialSelection],
      validValues: [],
      invalidValues: [],
      chipSize: 'small'
    }
  },
  computed: {
    searchSuggestions() {
      return this.$store.state.searchFields.suggestions
    },
    searchSuggestionsTotal() {
      return this.$store.state.searchFields.suggestionsTotal
    },
    searchSuggestionsLoading() {
      return this.$store.state.searchFields.suggestionsLoading
    },
    searchSuggestionsError() {
      return this.$store.state.searchFields.suggestionsError
    },
    validatedValues() {
      return this.$store.state.searchFields.validatedValues
    },
    validatedError() {
      return this.$store.state.searchFields.validatedError
    },
    allSelectedValues() {
      return [...this.pendingValues, ...this.invalidValues, ...this.validValues]
    },
    buttonClasses() {
      return [
        'select',
        this.size,
        {
          'full-width': this.fullWidth,
          selected: this.allSelectedValues.length
        }
      ]
    },
    buttonLabel() {
      const numSelected = this.allSelectedValues.length
      if (numSelected === 0) {
        return this.label
      }
      if (numSelected === 1) {
        return this.allSelectedValues[0]
      }
      return numSelected + ' ' + this.label
    }
  },
  watch: {
    validatedValues(values) {
      for (const pendingValue of this.pendingValues) {
        if (values.includes(pendingValue)) {
          this.validValues.push(pendingValue)
        } else {
          this.invalidValues.push(pendingValue)
        }
      }
      this.pendingValues = []
    }
  },
  mounted() {
    this.validatePendingValues()
  },
  methods: {
    toggleDropdown() {
      if (!this.dropdownOpen) {
        this.dropdownOpen = true
        this.$nextTick(() => {
          const boundingClientRect = this.$refs.dropdown.getBoundingClientRect()
          this.dropdownTop = boundingClientRect.top
          this.$refs.searchInput.focusInput()
        })
      } else {
        this.closeDropdown()
      }
    },
    closeDropdown() {
      this.dropdownOpen = false
      this.$refs.button.focus()
    },
    onDropdownFocusOut(e) {
      if (!e.currentTarget.contains(e.relatedTarget)) {
        this.closeDropdown()
      }
    },
    onOptionSelect(value) {
      // could optimise to skip pending state here as we know it's valid
      this.onSearchEnter(value)
    },
    onSearchChange(value) {
      if (value.includes(',')) {
        // simulate empty input to clear search suggestions
        value = ''
      }
      this.$store.dispatch(`searchFields/getSuggestions`, {
        filterId: this.filterId,
        filterValue: value,
        suggestionLimit: this.suggestionLimit
      })
    },
    onSearchEnter(inputValue) {
      const values = inputValue
        .trim()
        .split(/\s*,\s*/)
        .filter(
          (value, index, arr) =>
            value &&
            arr.indexOf(value) === index &&
            !this.allSelectedValues.includes(value)
        )
      this.pendingValues = [...values, ...this.pendingValues]
      this.validatePendingValues()
      this.$refs.searchInput.clearInput()
      this.$refs.searchInput.focusInput()
      this.selectionChanged()
    },
    validatePendingValues() {
      if (this.pendingValues.length) {
        this.$refs.searchInput.focusInput()
        this.$store.dispatch(`searchFields/validateValues`, {
          filterId: this.filterId,
          filterValues: this.allSelectedValues
        })
      }
    },
    selectNone() {
      this.validValues = []
      this.pendingValues = []
      this.invalidValues = []
      this.$refs.searchInput.clearInput()
      this.$refs.searchInput.focusInput()
      this.selectionChanged()
    },
    selectionChanged() {
      /**
       * Selection was changed
       * @param {String[]} values All currently selected values
       */
      this.$emit('change', this.allSelectedValues)
    },
    removeValue(prop, value) {
      // refocus the search input otherwise the focus is on the chip
      // and when the chip is removed is closes the dropdown
      this.$refs.searchInput.focusInput()

      this[prop] = this[prop].filter((val) => val !== value)
      this.selectionChanged()
    }
  }
}
</script>

<style lang="scss" scoped>
.sa-multisearch {
  position: relative;

  .dropdown {
    max-height: 100vh;
    min-width: 240px;
  }
}

.select {
  &:not(.full-width) {
    max-width: 20rem;
  }
  span {
    overflow: hidden;
    white-space: nowrap;
    text-overflow: ellipsis;
  }
}

.header {
  position: sticky;
  top: 0;
  margin: 1px;
  padding-bottom: spacing(1);
  background: color(white);
  z-index: 10;
}

.label {
  display: flex;
  justify-content: space-between;
}

.link-button {
  font-size: font-size(0);
  text-decoration: underline;
  color: color(primary);

  &:hover,
  &:focus {
    text-decoration: none;
    color: color(grey);
  }
}

.search-input {
  width: 100%;
}

.search-options-loading {
  font-size: font-size(0);
  color: color(grey);
}

.result-section {
  &:not(.pending-section) {
    border-top: 1px solid color(grey-light);
  }

  padding: spacing(1) spacing(2);
}
</style>
